# coding: utf-8

"""
    PassHub API

    PassHub API documentation  # noqa: E501

    OpenAPI spec version: 1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from sightseeingtech_passhub_api.api_client import ApiClient


class OrderRecordResourceApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_order_record(self, order_record_dto, **kwargs):  # noqa: E501
        """createOrderRecord  # noqa: E501

        1) Cellphone number must be in E.164 format;<br/>2) «PricePaid» is a price for 1 product;<br/>3) Required permissions: CAN_CREATE_ORDER.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_order_record(order_record_dto, async=True)
        >>> result = thread.get()

        :param async bool
        :param OrderRecordDTO order_record_dto: the OrderRecord Dto (required)
        :return: OrderRecordDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_order_record_with_http_info(order_record_dto, **kwargs)  # noqa: E501
        else:
            (data) = self.create_order_record_with_http_info(order_record_dto, **kwargs)  # noqa: E501
            return data

    def create_order_record_with_http_info(self, order_record_dto, **kwargs):  # noqa: E501
        """createOrderRecord  # noqa: E501

        1) Cellphone number must be in E.164 format;<br/>2) «PricePaid» is a price for 1 product;<br/>3) Required permissions: CAN_CREATE_ORDER.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_order_record_with_http_info(order_record_dto, async=True)
        >>> result = thread.get()

        :param async bool
        :param OrderRecordDTO order_record_dto: the OrderRecord Dto (required)
        :return: OrderRecordDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['order_record_dto']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_order_record" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'order_record_dto' is set
        if ('order_record_dto' not in params or
                params['order_record_dto'] is None):
            raise ValueError("Missing the required parameter `order_record_dto` when calling `create_order_record`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'order_record_dto' in params:
            body_params = params['order_record_dto']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/orderRecords', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='OrderRecordDTO',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_order_records(self, **kwargs):  # noqa: E501
        """getAllOrderRecords  # noqa: E501

        Required permissions: CAN_GET_ORDERS  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_all_order_records(async=True)
        >>> result = thread.get()

        :param async bool
        :param str query: query text
        :param str _from: Begin the of date range, format: YYYY-MM-DD (e.g. 2016-01-25)
        :param str till: End the of date range, format: YYYY-MM-DD (e.g. 2016-01-25)
        :param str time_zone: A timezone for date/time representation. Example: America/Chicago or EST. If zone is not set, then UTC timezone will be used.
        :param str delivery_method: delivery method
        :param str delivery_status: status of delivery
        :param int size: quantity of listed records on page
        :param int page: listing starts from page value
        :param str sort_by: sort by
        :param str sort_order: sort order
        :return: list[OrderRecordExtendDTO]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_all_order_records_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_all_order_records_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_all_order_records_with_http_info(self, **kwargs):  # noqa: E501
        """getAllOrderRecords  # noqa: E501

        Required permissions: CAN_GET_ORDERS  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_all_order_records_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :param str query: query text
        :param str _from: Begin the of date range, format: YYYY-MM-DD (e.g. 2016-01-25)
        :param str till: End the of date range, format: YYYY-MM-DD (e.g. 2016-01-25)
        :param str time_zone: A timezone for date/time representation. Example: America/Chicago or EST. If zone is not set, then UTC timezone will be used.
        :param str delivery_method: delivery method
        :param str delivery_status: status of delivery
        :param int size: quantity of listed records on page
        :param int page: listing starts from page value
        :param str sort_by: sort by
        :param str sort_order: sort order
        :return: list[OrderRecordExtendDTO]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['query', '_from', 'till', 'time_zone', 'delivery_method', 'delivery_status', 'size', 'page', 'sort_by', 'sort_order']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_order_records" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'till' in params:
            query_params.append(('till', params['till']))  # noqa: E501
        if 'time_zone' in params:
            query_params.append(('timeZone', params['time_zone']))  # noqa: E501
        if 'delivery_method' in params:
            query_params.append(('deliveryMethod', params['delivery_method']))  # noqa: E501
        if 'delivery_status' in params:
            query_params.append(('deliveryStatus', params['delivery_status']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'sort_by' in params:
            query_params.append(('sortBy', params['sort_by']))  # noqa: E501
        if 'sort_order' in params:
            query_params.append(('sortOrder', params['sort_order']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/api/v2/orderRecords', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[OrderRecordExtendDTO]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_order_record(self, id, **kwargs):  # noqa: E501
        """getOrderRecord  # noqa: E501

        Required permissions: CAN_GET_ORDERS  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_order_record(id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int id: the internal id of order (required)
        :return: OrderRecordExtendDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_order_record_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_order_record_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def get_order_record_with_http_info(self, id, **kwargs):  # noqa: E501
        """getOrderRecord  # noqa: E501

        Required permissions: CAN_GET_ORDERS  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_order_record_with_http_info(id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int id: the internal id of order (required)
        :return: OrderRecordExtendDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_order_record" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_order_record`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/orderRecords/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='OrderRecordExtendDTO',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def merge_vouchers(self, order_id, new_voucher_id, **kwargs):  # noqa: E501
        """mergeVouchers  # noqa: E501

        Replaces voucher IDs of order items with new voucher ID in the specified order. All groups are merged to one 'MergedGroup'.<br/>Required permissions: CAN_EDIT_ORDER  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.merge_vouchers(order_id, new_voucher_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int order_id: the internal id of order (required)
        :param str new_voucher_id: newVoucherId (required)
        :return: GenericStatusDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.merge_vouchers_with_http_info(order_id, new_voucher_id, **kwargs)  # noqa: E501
        else:
            (data) = self.merge_vouchers_with_http_info(order_id, new_voucher_id, **kwargs)  # noqa: E501
            return data

    def merge_vouchers_with_http_info(self, order_id, new_voucher_id, **kwargs):  # noqa: E501
        """mergeVouchers  # noqa: E501

        Replaces voucher IDs of order items with new voucher ID in the specified order. All groups are merged to one 'MergedGroup'.<br/>Required permissions: CAN_EDIT_ORDER  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.merge_vouchers_with_http_info(order_id, new_voucher_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int order_id: the internal id of order (required)
        :param str new_voucher_id: newVoucherId (required)
        :return: GenericStatusDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['order_id', 'new_voucher_id']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method merge_vouchers" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'order_id' is set
        if ('order_id' not in params or
                params['order_id'] is None):
            raise ValueError("Missing the required parameter `order_id` when calling `merge_vouchers`")  # noqa: E501
        # verify the required parameter 'new_voucher_id' is set
        if ('new_voucher_id' not in params or
                params['new_voucher_id'] is None):
            raise ValueError("Missing the required parameter `new_voucher_id` when calling `merge_vouchers`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'order_id' in params:
            query_params.append(('orderId', params['order_id']))  # noqa: E501
        if 'new_voucher_id' in params:
            query_params.append(('newVoucherId', params['new_voucher_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/orderRecords/mergeVouchers', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GenericStatusDTO',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_order_record(self, order_record_dto, **kwargs):  # noqa: E501
        """updateOrderRecord  # noqa: E501

        1) Cellphone number must be in E.164 format;<br/>2) «PricePaid» is a price for 1 product;<br/>3) Required permissions: CAN_EDIT_ORDER.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_order_record(order_record_dto, async=True)
        >>> result = thread.get()

        :param async bool
        :param OrderRecordDTO order_record_dto: the OrderRecord Dto (required)
        :return: OrderRecordDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.update_order_record_with_http_info(order_record_dto, **kwargs)  # noqa: E501
        else:
            (data) = self.update_order_record_with_http_info(order_record_dto, **kwargs)  # noqa: E501
            return data

    def update_order_record_with_http_info(self, order_record_dto, **kwargs):  # noqa: E501
        """updateOrderRecord  # noqa: E501

        1) Cellphone number must be in E.164 format;<br/>2) «PricePaid» is a price for 1 product;<br/>3) Required permissions: CAN_EDIT_ORDER.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_order_record_with_http_info(order_record_dto, async=True)
        >>> result = thread.get()

        :param async bool
        :param OrderRecordDTO order_record_dto: the OrderRecord Dto (required)
        :return: OrderRecordDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['order_record_dto']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_order_record" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'order_record_dto' is set
        if ('order_record_dto' not in params or
                params['order_record_dto'] is None):
            raise ValueError("Missing the required parameter `order_record_dto` when calling `update_order_record`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'order_record_dto' in params:
            body_params = params['order_record_dto']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/orderRecords', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='OrderRecordDTO',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
