# coding: utf-8

"""
    PassHub API

    PassHub API documentation  # noqa: E501

    OpenAPI spec version: 1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from sightseeingtech_passhub_api.api_client import ApiClient


class ProductResourceApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def find_products_by_vendor(self, vendor_id, **kwargs):  # noqa: E501
        """findProductsByVendor  # noqa: E501

        Required permissions: CAN_GET_PRODUCTS_BY_VENDOR  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.find_products_by_vendor(vendor_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int vendor_id: the internal vendor id (required)
        :return: list[ProductDTO]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.find_products_by_vendor_with_http_info(vendor_id, **kwargs)  # noqa: E501
        else:
            (data) = self.find_products_by_vendor_with_http_info(vendor_id, **kwargs)  # noqa: E501
            return data

    def find_products_by_vendor_with_http_info(self, vendor_id, **kwargs):  # noqa: E501
        """findProductsByVendor  # noqa: E501

        Required permissions: CAN_GET_PRODUCTS_BY_VENDOR  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.find_products_by_vendor_with_http_info(vendor_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int vendor_id: the internal vendor id (required)
        :return: list[ProductDTO]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vendor_id']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method find_products_by_vendor" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vendor_id' is set
        if ('vendor_id' not in params or
                params['vendor_id'] is None):
            raise ValueError("Missing the required parameter `vendor_id` when calling `find_products_by_vendor`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vendor_id' in params:
            path_params['vendorId'] = params['vendor_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/api/v1/products/vendor/{vendorId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ProductDTO]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_products(self, **kwargs):  # noqa: E501
        """getAllProducts  # noqa: E501

        Required permissions: CAN_GET_PRODUCTS  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_all_products(async=True)
        >>> result = thread.get()

        :param async bool
        :param str query: query text
        :param int size: quantity of listed records on page
        :param int page: listing starts from page value
        :param str sort_by: sort by
        :param str sort_order: sort order
        :param str type: product type
        :param list[str] tag_filter: tagFilter
        :param str tag_filter_mode: tagFilterMode
        :return: list[ProductDTO]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_all_products_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_all_products_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_all_products_with_http_info(self, **kwargs):  # noqa: E501
        """getAllProducts  # noqa: E501

        Required permissions: CAN_GET_PRODUCTS  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_all_products_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :param str query: query text
        :param int size: quantity of listed records on page
        :param int page: listing starts from page value
        :param str sort_by: sort by
        :param str sort_order: sort order
        :param str type: product type
        :param list[str] tag_filter: tagFilter
        :param str tag_filter_mode: tagFilterMode
        :return: list[ProductDTO]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['query', 'size', 'page', 'sort_by', 'sort_order', 'type', 'tag_filter', 'tag_filter_mode']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_products" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'sort_by' in params:
            query_params.append(('sortBy', params['sort_by']))  # noqa: E501
        if 'sort_order' in params:
            query_params.append(('sortOrder', params['sort_order']))  # noqa: E501
        if 'type' in params:
            query_params.append(('type', params['type']))  # noqa: E501
        if 'tag_filter' in params:
            query_params.append(('tagFilter', params['tag_filter']))  # noqa: E501
            collection_formats['tagFilter'] = 'csv'  # noqa: E501
        if 'tag_filter_mode' in params:
            query_params.append(('tagFilterMode', params['tag_filter_mode']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/api/v2/products', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ProductDTO]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
